## isakmpd 20040204-1

=== Makefile ===
#	$OpenBSD: Makefile,v 1.50 2003/08/28 14:43:35 markus Exp $
#	$EOM: Makefile,v 1.78 2000/10/15 21:33:42 niklas Exp $

#
# Copyright (c) 1998, 1999, 2000, 2001 Niklas Hallqvist.  All rights reserved.
# Copyright (c) 2000, 2001 Hkan Olsson.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This code was written under funding by Ericsson Radio Systems.
#

#
# This makefile is a "pmake" one, i.e. the make variant commonly found in
# BSD derived systems, where it is indeed named "make".  Other systems
# may provide this make variant as "pmake" or maybe "bsdmake".
#

# openbsd means OpenBSD 2.5 or newer. freeswan is the name for Linux with
# FreeS/WAN integrated, freebsd/netbsd means FreeBSD/NetBSD with KAME IPsec.
OS=		openbsd
#OS=		netbsd
#OS=		freebsd
#OS=		freeswan
#OS=		bsdi

# Compile-time configuration of otherwise optional features
#FEATURES=	tripledes des blowfish cast aes
#FEATURES+=	policy x509 ec aggressive debug gmp
#FEATURES+=	rawkey isakmp_cfg dnssec privsep
FEATURES=	tripledes des blowfish cast aes
FEATURES+=	policy x509 ec aggressive debug
FEATURES+=	rawkey isakmp_cfg

.PATH:		${.CURDIR}/sysdep/${OS}

PROG=		isakmpd
BINDIR?=	/sbin
LDSTATIC?=	-static
SRCS=		app.c attribute.c cert.c connection.c constants.c conf.c \
		cookie.c crypto.c dh.c doi.c exchange.c exchange_num.c \
		field.c gmp_util.c hash.c if.c ike_auth.c ike_main_mode.c \
		ike_phase_1.c ike_quick_mode.c init.c ipsec.c ipsec_fld.c \
		ipsec_num.c isakmpd.c isakmp_doi.c isakmp_fld.c isakmp_num.c \
		key.c libcrypto.c log.c message.c math_2n.c math_group.c \
		prf.c sa.c sysdep.c timer.c transport.c udp.c ui.c util.c

GENERATED=	exchange_num.h ipsec_fld.h ipsec_num.h isakmp_fld.h \
		isakmp_num.h
CLEANFILES=	exchange_num.c exchange_num.h ipsec_num.c ipsec_num.h \
		isakmp_num.c isakmp_num.h ipsec_fld.c ipsec_fld.h \
		isakmp_fld.c isakmp_fld.h
MAN=		isakmpd.8 isakmpd.conf.5 isakmpd.policy.5
CFLAGS+=	-Wall -Wstrict-prototypes -Wmissing-prototypes \
		-DNEED_SYSDEP_APP \
		-I${.CURDIR} -I${.CURDIR}/sysdep/${OS} -I.
#CFLAGS+=	-Wsign-compare -Werror

# Different debugging & profiling suggestions

# Include symbolic debugging info
#DEBUG=		-g	# OpenBSD
#DEBUG_FLAGS=	-g	# FreeBSD
#CFLAGS+=	-g	# NetBSD and others
#STRIPFLAG=		# NETBSD

# Do execution time profiles
#CFLAGS+=	-pg

# If you have ElectricFence available, you can spot abuses of the heap.
# (/usr/ports/devel/ElectricFence)
#LDADD+=		-L/usr/local/lib -lefence
#DPADD+=		/usr/local/lib/libefence.a

# If you like to use Boehm's garbage collector (/usr/ports/devel/boehm-gc).
#LDADD+=		-L/usr/local/lib -lgc
#DPADD+=		/usr/local/lib/libgc.a

# You can also use Boehm's garbage collector as a means to find leaks.
# XXX The defines below are GCC-specific.  I think it is OK to require
# XXX GCC if you are debugging isakmpd in this way.
#LDADD+=		-L/usr/local/lib -lleak
#DPADD+=		/usr/local/lib/libleak.a
#CFLAGS+=	-D'malloc(x)=({ \
#		  void *GC_debug_malloc (size_t, char *, int); \
#		  GC_debug_malloc ((x), __FILE__, __LINE__); \
#		})' \
#		-D'realloc(x,y)=({ \
#		  void *GC_debug_realloc (void *, size_t, char *, int); \
#		  GC_debug_realloc ((x), (y), __FILE__, __LINE__); \
#		})' \
#		-D'free(x)=({ \
#		  void GC_debug_free (void *); \
#		  GC_debug_free (x); \
#		})' \
#		-D'calloc(x,y)=malloc((x) * (y))' \
#		-D'strdup(x)=({ \
#		  char *strcpy (char *, const char *); \
#		  const char *_x_ = (x); \
#		  char *_y_ = malloc (strlen (_x_) + 1); \
#		  strcpy (_y_, _x_); \
#		})'

SUBDIR=		apps

.include "sysdep/${OS}/Makefile.sysdep"

.if ${FEATURES} != ""
FEATURES_UC!=	echo ${FEATURES} | tr '[:lower:]' '[:upper:]'
CFLAGS+=	${FEATURES_UC:S/^/-DUSE_/g}
.endif

.if make(install)
SUBDIR+=	samples
.endif

.if !make(install) && !defined(NO_REGRESS)
SUBDIR+=	regress
.endif

.for FEATURE in ${FEATURES}
.if exists(features/${FEATURE})
.include "features/${FEATURE}"
.endif
.endfor

.if ${FEATURES:Mgmp} == "gmp"
CFLAGS+=	-DMP_FLAVOUR=MP_FLAVOUR_GMP
LDADD+=		-lgmp
DPADD+=		${LIBGMP}
.else
CFLAGS+=	-DMP_FLAVOUR=MP_FLAVOUR_OPENSSL
.endif

.ifdef USE_KEYNOTE
USE_LIBCRYPTO=	yes
USE_LIBDES=	yes
LDADD+=		-lkeynote -lm
DPADD+=		${LIBKEYNOTE} ${LIBM}
CFLAGS+=	-DUSE_KEYNOTE
.endif

.ifdef USE_RAWKEY
USE_LIBCRYPTO=	yes
CFLAGS+=	-DUSE_RAWKEY
.endif

.ifdef USE_LIBCRYPTO
CFLAGS+=	-DUSE_LIBCRYPTO
LDADD+=		-lcrypto
DPADD+=		${LIBCRYPTO}
.endif

.ifdef USE_LIBDES
CFLAGS+=	-DUSE_LIBDES
LDADD+=		-ldes
DPADD+=		${LIBDES}
.endif

SRCS+=		${IPSEC_SRCS} ${X509} ${POLICY} ${EC} ${AGGRESSIVE} ${DNSSEC} \
		${ISAKMP_CFG} ${PRIVSEP}
CFLAGS+=	${IPSEC_CFLAGS} ${DNSSEC_CFLAGS}

LDADD+=		${DESLIB} ${LWRESLIB}
DPADD+=		${DESLIBDEP} ${LWRESLIB}

exchange_num.c exchange_num.h: genconstants.sh exchange_num.cst
	/bin/sh ${.CURDIR}/genconstants.sh ${.CURDIR}/exchange_num

ipsec_fld.c ipsec_fld.h: genfields.sh ipsec_fld.fld
	/bin/sh ${.CURDIR}/genfields.sh ${.CURDIR}/ipsec_fld

ipsec_num.c ipsec_num.h: genconstants.sh ipsec_num.cst
	/bin/sh ${.CURDIR}/genconstants.sh ${.CURDIR}/ipsec_num

isakmp_fld.c isakmp_fld.h: genfields.sh isakmp_fld.fld
	/bin/sh ${.CURDIR}/genfields.sh ${.CURDIR}/isakmp_fld

isakmp_num.c isakmp_num.h: genconstants.sh isakmp_num.cst
	/bin/sh ${.CURDIR}/genconstants.sh ${.CURDIR}/isakmp_num

${PROG} beforedepend: ${GENERATED}

.include <bsd.prog.mk>
.include <bsd.subdir.mk>

=== debian/changelog ===
isakmpd (20040204-1) unstable; urgency=low

  * Provide ike-server (closes: #223784).
  * Fixes for big indian systems (thanks to Sebastian Klemke).
    (closes: #223845).
  * Fix for certificates file access on non ext2 enabled kernel
    systems, thanks to jochen. (closes: #225474).
  * Update kernel version informations. (closes: #229795).
  * New upstream cvs merge.
  * Added missing man page isakmpd.policy(5) (thanks to  Toni Mueller).
    (closes: #231123).

 -- Jean-Francois Dive <jef@debian.org>  Sun,  8 Feb 2004 20:55:34 +0100

isakmpd (20031107-2) unstable; urgency=high

  * SECURITY fix for INITIAL_CONTACT handeling. (previous
    release actually did fixed INVALID_SPI informational exchange
    security issue). The problem is the exact same nature for both
    type of informational messages: because the end result is SA
    deletation, the HASH payload should be in the message and checked.

 -- Jean-Francois Dive <jef@debian.org>  Thu, 13 Nov 2003 14:54:01 +0100

isakmpd (20031107-1) unstable; urgency=high

  * new upstream cvs merge.
  * SECURITY fix for HASH payload handeling (closes: #219864).
  * SECURITY fix handeling of quick mode exchange encryption (it now
    does require quick mode to be encrypted both Rx/Tx).
  * SECURITY fix for INITIAL_CONTACT handeling (did not check for 
    mandatory HASH payload).
  * Updated linux kernel header for interop with debian x86 kernels.
  * Fix issues with policy handeling in keynote.

 -- Jean-Francois Dive <jef@debian.org>  Thu, 13 Nov 2003 11:05:09 +0100

isakmpd (20030907-1) unstable; urgency=high

  * new upstream cvs merge.
  * Fixed kernel interface due to ABI changes in linux IPSec.
  * Fixed keynote issue.

 -- Jean-Francois Dive <jef@debian.org>  Wed, 10 Sep 2003 22:47:17 +0200

isakmpd (20030718-1) unstable; urgency=high

  * New upstream version.
  * Merged new upstream linux native build support.
  * Added fine grained selector support to upstream linux native sysdep.
  * Removed useless libc and kernel headers.
  * Removed libdes.
  * Added generated upstream changelog (generated by cvs2cl.pl).

 -- Jean-Francois Dive <jef@debian.org>  Tue, 22 Jul 2003 12:15:30 +0200

isakmpd (20030119-2) unstable; urgency=low

  * Fixed init script (closes: #188086).
  * Added support for Protocol and Port text definition in ID handeling.
    (expl: Protocol = icmp instead of Protocol = 1).

 -- Jean-Francois Dive <jef@debian.org>  Mon,  9 Jun 2003 14:11:02 +0200

isakmpd (20030119-1) unstable; urgency=low

  * Changed version number to a sane format.

 -- Jean-Francois Dive <jef@debian.org>  Thu, 20 Mar 2003 18:46:56 +0100

isakmpd (19012003-4) unstable; urgency=low

  * Fixed source tree clean issues (libdes, libsysdep) (closes: #184295).
  * Added diff to package upload.

 -- Jean-Francois Dive <jef@debian.org>  Tue, 18 Mar 2003 17:30:57 +0100

isakmpd (19012003-3) unstable; urgency=low

  * switched libdes copyright from copyright.libdes to
    copyright file.

 -- Jean-Francois Dive <jef@debian.org>  Thu, 20 Feb 2003 13:10:54 +1100

isakmpd (19012003-2) unstable; urgency=low

  * Added reference to BSD license and libdes license.
  * Renmoved double dependency on libssl.
  * Removed /usr/doc link.
  * Added lintian overrides.

 -- Jean-Francois Dive <jef@debian.org>  Sun, 26 Jan 2003 00:36:40 +1100

isakmpd (19012003-1) unstable; urgency=low

  * Inital debianization (Closes: #163904).

 -- Jean-Francois Dive <jef@debian.org>  Sun, 26 Jan 2003 00:36:40 +1100

=== debian/control ===
Source: isakmpd
Maintainer: Jean-Francois Dive <jef@debian.org>
Priority: optional
Section: net
Standards-Version: 3.5.6
Build-Depends: debhelper (>= 3.0.5), libkeynote-dev, libssl-dev, libgmp3-dev

Package: isakmpd
Priority: optional
Section: net
Architecture: any
Provides: ike-server
Depends: ${shlibs:Depends}, libkeynote0
Description: The Internet Key Exchange protocol openbsd implementation
 IKE is a protocol which allow to exchange security information between
 to peers. This implementation requires the native linux ipsec support.

=== debian/rules ===
#!/usr/bin/make -f

export DH_COMPAT := 3

b := $(CURDIR)/debian/isakmpd

arrange: arrange-stamp
arrange-stamp: install
	dh_testdir
	touch arrange-stamp

binary: binary-stamp
binary-stamp: binary-indep binary-arch
	dh_testdir
	touch binary-stamp

binary-arch: binary-arch-stamp
binary-arch-stamp: arrange
	dh_testdir
	dh_testroot
	dh_installdocs -n DESIGN-NOTES QUESTIONS README README.PKI TO-DO $(CURDIR)/debian/README.Debian
	cp $(CURDIR)/samples/*.conf $(b)/usr/share/doc/isakmpd/samples/
	cp $(CURDIR)/samples/VPN-east.conf $(b)/etc/isakmpd/isakmpd.conf
	cp $(CURDIR)/samples/policy $(b)/etc/isakmpd/isakmpd.policy
	cp $(CURDIR)/isakmpd $(b)/usr/sbin/
	cp $(CURDIR)/debian/isakmpd.lintian $(b)/usr/share/lintian/overrides/isakmpd
	dh_installman isakmpd.8 isakmpd.conf.5 isakmpd.policy.5
	dh_installinit
	dh_installchangelogs $(CURDIR)/debian/ChangeLog upstream
	dh_compress
	dh_fixperms
	find $(b)/etc/isakmpd -type d | xargs chmod 0700
	find $(b)/etc/isakmpd -type f | xargs chmod 0600
	dh_strip
	dh_installdeb
	dh_perl
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb
	touch binary-arch-stamp

binary-indep: binary-indep-stamp
binary-indep-stamp: arrange
	dh_testdir
	touch binary-indep-stamp

build: build-stamp
build-stamp: config
	dh_testdir
	$(MAKE)
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	$(MAKE) clean
	dh_clean arrange-stamp binary-stamp binary-arch-stamp binary-indep-stamp build-stamp config-stamp install-stamp 
	find $(CURDIR) -type f -name ".depend" | xargs rm -f

config: config-stamp
config-stamp:
	dh_testdir
	touch config-stamp

install: install-stamp
install-stamp: build
	dh_testdir
	dh_installdirs
	touch install-stamp

.PHONY: arrange binary binary-arch binary-indep build clean config install

## isakmpd 20041012

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-#	$OpenBSD: Makefile,v 1.50 2003/08/28 14:43:35 markus Exp $
+#	$OpenBSD: Makefile,v 1.57 2004/08/23 11:16:49 ho Exp $
 #	$EOM: Makefile,v 1.78 2000/10/15 21:33:42 niklas Exp $
 
 #
@@ -47,10 +47,10 @@
 # Compile-time configuration of otherwise optional features
 #FEATURES=	tripledes des blowfish cast aes
 #FEATURES+=	policy x509 ec aggressive debug gmp
-#FEATURES+=	rawkey isakmp_cfg dnssec privsep
+#FEATURES+=	rawkey isakmp_cfg dnssec privsep nat_traversal dpd
 FEATURES=	tripledes des blowfish cast aes
 FEATURES+=	policy x509 ec aggressive debug
-FEATURES+=	rawkey isakmp_cfg
+FEATURES+=	rawkey isakmp_cfg privsep nat_traversal dpd
 
 .PATH:		${.CURDIR}/sysdep/${OS}
 
@@ -63,7 +63,8 @@
 		ike_phase_1.c ike_quick_mode.c init.c ipsec.c ipsec_fld.c \
 		ipsec_num.c isakmpd.c isakmp_doi.c isakmp_fld.c isakmp_num.c \
 		key.c libcrypto.c log.c message.c math_2n.c math_group.c \
-		prf.c sa.c sysdep.c timer.c transport.c udp.c ui.c util.c
+		prf.c sa.c sysdep.c timer.c transport.c virtual.c udp.c \
+		ui.c util.c
 
 GENERATED=	exchange_num.h ipsec_fld.h ipsec_num.h isakmp_fld.h \
 		isakmp_num.h
@@ -72,7 +73,7 @@
 		isakmp_fld.c isakmp_fld.h
 MAN=		isakmpd.8 isakmpd.conf.5 isakmpd.policy.5
 CFLAGS+=	-Wall -Wstrict-prototypes -Wmissing-prototypes \
-		-DNEED_SYSDEP_APP \
+		-Wmissing-declarations -DNEED_SYSDEP_APP \
 		-I${.CURDIR} -I${.CURDIR}/sysdep/${OS} -I.
 #CFLAGS+=	-Wsign-compare -Werror
 
@@ -95,31 +96,9 @@
 # If you like to use Boehm's garbage collector (/usr/ports/devel/boehm-gc).
 #LDADD+=		-L/usr/local/lib -lgc
 #DPADD+=		/usr/local/lib/libgc.a
-
+#CFLAGS+=		-DUSE_BOEHM_GC -DGC_DEBUG
 # You can also use Boehm's garbage collector as a means to find leaks.
-# XXX The defines below are GCC-specific.  I think it is OK to require
-# XXX GCC if you are debugging isakmpd in this way.
-#LDADD+=		-L/usr/local/lib -lleak
-#DPADD+=		/usr/local/lib/libleak.a
-#CFLAGS+=	-D'malloc(x)=({ \
-#		  void *GC_debug_malloc (size_t, char *, int); \
-#		  GC_debug_malloc ((x), __FILE__, __LINE__); \
-#		})' \
-#		-D'realloc(x,y)=({ \
-#		  void *GC_debug_realloc (void *, size_t, char *, int); \
-#		  GC_debug_realloc ((x), (y), __FILE__, __LINE__); \
-#		})' \
-#		-D'free(x)=({ \
-#		  void GC_debug_free (void *); \
-#		  GC_debug_free (x); \
-#		})' \
-#		-D'calloc(x,y)=malloc((x) * (y))' \
-#		-D'strdup(x)=({ \
-#		  char *strcpy (char *, const char *); \
-#		  const char *_x_ = (x); \
-#		  char *_y_ = malloc (strlen (_x_) + 1); \
-#		  strcpy (_y_, _x_); \
-#		})'
+#  # setenv GC_FIND_LEAK
 
 SUBDIR=		apps
 
@@ -178,7 +157,7 @@
 .endif
 
 SRCS+=		${IPSEC_SRCS} ${X509} ${POLICY} ${EC} ${AGGRESSIVE} ${DNSSEC} \
-		${ISAKMP_CFG} ${PRIVSEP}
+		${ISAKMP_CFG} ${PRIVSEP} ${DPD} ${NAT_TRAVERSAL}
 CFLAGS+=	${IPSEC_CFLAGS} ${DNSSEC_CFLAGS}
 
 LDADD+=		${DESLIB} ${LWRESLIB}
@@ -203,3 +182,6 @@
 
 .include <bsd.prog.mk>
 .include <bsd.subdir.mk>
+
+debug:
+	(cd ${.CURDIR}; ${MAKE} DEBUG="-g -Werror")

=== apps/Makefile ===
#	$OpenBSD: Makefile,v 1.2 2003/06/03 14:35:00 ho Exp $
#	$EOM: Makefile,v 1.2 1999/07/17 20:44:12 niklas Exp $

#
# Copyright (c) 1999 Niels Provos.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This code was written under funding by Ericsson Radio Systems.
#

SUBDIR= certpatch

.include <bsd.subdir.mk>

=== regress/Makefile ===
#	$OpenBSD: Makefile,v 1.9 2003/06/03 14:39:50 ho Exp $
#	$EOM: Makefile,v 1.8 1999/07/17 20:44:13 niklas Exp $

#
# Copyright (c) 1998, 1999 Niklas Hallqvist.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This code was written under funding by Ericsson Radio Systems.
#

SUBDIR=	b2n crypto dh ec2n exchange group hmac prf rsakeygen util x509

.include <bsd.subdir.mk>

=== samples/Makefile ===
#	$OpenBSD: Makefile,v 1.2 2003/06/03 14:39:50 ho Exp $
#	$EOM: Makefile,v 1.1 2000/05/01 20:04:53 niklas Exp $

#
# Copyright (c) 2000 Niklas Hallqvist.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

FILES=		VPN-* policy singlehost-*
TARGETDIR=	/usr/share/ipsec/isakmpd

# The mkdir below is for installation on OpenBSD pre 2.7
install:
	@-mkdir -p ${DESTDIR}${TARGETDIR}
	$(INSTALL) -c -m 0444 ${FILES} ${DESTDIR}${TARGETDIR}

=== apps/certpatch/Makefile ===
#	$OpenBSD: Makefile,v 1.7 2003/06/03 14:35:00 ho Exp $
#	$EOM: Makefile,v 1.6 2000/03/28 21:22:06 ho Exp $

#
# Copyright (c) 1999 Niels Provos.  All rights reserved.
# Copyright (c) 2001 Niklas Hallqvist.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This code was written under funding by Ericsson Radio Systems.
#

PROG=		certpatch
SRCS=		certpatch.c
BINDIR?=	/usr/sbin
TOPSRC=		${.CURDIR}/../..
TOPOBJ!=	cd ${TOPSRC}; printf "all:\n\t@pwd\n" |${MAKE} -f-
OS!=		awk '/^OS=/ { print $$2 }' ${.CURDIR}/../../Makefile
FEATURES!=	awk '/^FEATURES=/ { print $$0 }' ${.CURDIR}/../../Makefile | sed 's/FEATURES=.//'
.PATH:		${TOPSRC} ${TOPSRC}/sysdep/${OS} ${TOPOBJ}
CFLAGS+=	-I${TOPSRC} -I${TOPSRC}/sysdep/${OS} -I${TOPOBJ} -Wall
LDADD+=		-lcrypto
DPADD+=		${LIBCRYPTO}
MAN=		certpatch.8

.if ${FEATURES:Mgmp} == "gmp"
CFLAGS+=	-DMP_FLAVOUR=MP_FLAVOUR_GMP
LDADD+=		-lgmp
DPADD+=		${LIBGMP}
.else
CFLAGS+=	-DMP_FLAVOUR=MP_FLAVOUR_OPENSSL
.endif

.include "${TOPSRC}/sysdep/${OS}/Makefile.sysdep"
# Override LIBSYSDEPDIR definition from Makefile.sysdep
LIBSYSDEPDIR=	${TOPSRC}/sysdep/common/libsysdep

.include <bsd.prog.mk>

=== regress/b2n/Makefile ===
#	$OpenBSD: Makefile,v 1.7 2004/02/25 16:01:29 hshoexer Exp $
#	$EOM: Makefile,v 1.12 2000/10/13 13:04:17 ho Exp $

# Test some math

PROG=		b2ntest
SRCS=		b2ntest.c conf.c log.c math_2n.c sysdep.c util.c
NOMAN=
TOPSRC=		${.CURDIR}/../..
TOPOBJ!=	cd ${TOPSRC}; printf "all:\n\t@pwd\n" |${MAKE} -f-
OS!=		awk '/^OS=/ { print $$2 }' ${.CURDIR}/../../Makefile
.PATH:		${TOPSRC} ${TOPSRC}/sysdep/${OS} ${TOPOBJ}
CFLAGS+=	-I${TOPSRC} -I${TOPSRC}/sysdep/${OS} -I${TOPOBJ} -Wall
DEBUG=		-g

.include <bsd.prog.mk>

=== regress/crypto/Makefile ===
#	$OpenBSD: Makefile,v 1.11 2004/02/25 16:01:29 hshoexer Exp $
#	$EOM: Makefile,v 1.7 2000/03/28 21:22:06 ho Exp $

# Test Crypto:

PROG=		cryptotest
SRCS=		crypto.c cryptotest.c conf.c log.c sysdep.c util.c
TOPSRC=		${.CURDIR}/../..
TOPOBJ!=	cd ${TOPSRC}; printf "all:\n\t@pwd\n" |${MAKE} -f-
OS!=		awk '/^OS=/ { print $$2 }' ${.CURDIR}/../../Makefile
.PATH:		${TOPSRC} ${TOPSRC}/sysdep/${OS} ${TOPOBJ}
CFLAGS+=	-I${TOPSRC} -I${TOPSRC}/sysdep/${OS} -I${TOPOBJ} -Wall \
		-DUSE_TRIPLEDES -DUSE_CAST -DUSE_BLOWFISH -DUSE_DES \
		-DUSE_AES
LDADD+=		-lcrypto -ldes
DPADD+=		${LIBCRYPTO} ${LIBDES}
NOMAN=
DEBUG=		-g

.include <bsd.prog.mk>

=== regress/dh/Makefile ===
#	$OpenBSD: Makefile,v 1.8 2004/02/25 16:01:29 hshoexer Exp $
#	$EOM: Makefile,v 1.10 2000/04/07 20:19:43 niklas Exp $

# Test DH:

PROG=		dhtest
SRCS=		math_2n.c math_ec2n.c math_group.c dh.c dhtest.c log.c util.c \
		sysdep.c gmp_util.c conf.c
TOPSRC=		${.CURDIR}/../..
TOPOBJ!=	cd ${TOPSRC}; printf "all:\n\t@pwd\n" |${MAKE} -f-
OS!=		awk '/^OS=/ { print $$2 }' ${.CURDIR}/../../Makefile
FEATURES!=	awk '/^FEATURES=/ { print $$0 }' ${.CURDIR}/../../Makefile | sed 's/FEATURES=.//'
.PATH:		${TOPSRC} ${TOPSRC}/sysdep/${OS} ${TOPOBJ}
CFLAGS+=	-I${TOPSRC} -I${TOPSRC}/sysdep/${OS} -I${TOPOBJ} -Wall \
		-DUSE_EC
NOMAN=
LDADD+=		-lcrypto
DPADD+=		${LIBCRYPTO}
DEBUG=		-g

.if ${FEATURES:Mgmp} == "gmp"
CFLAGS+=	-DMP_FLAVOUR=MP_FLAVOUR_GMP
LDADD+=		-lgmp
DPADD+=		${LIBGMP}
.else
CFLAGS+=	-DMP_FLAVOUR=MP_FLAVOUR_OPENSSL
.endif

.include <bsd.prog.mk>

=== regress/ec2n/Makefile ===
#	$OpenBSD: Makefile,v 1.7 2004/02/25 16:01:29 hshoexer Exp $
#	$EOM: Makefile,v 1.9 2000/10/13 13:04:17 ho Exp $

# Test EC2N:

PROG=		ec2ntest
SRCS=		math_2n.c math_ec2n.c ec2ntest.c log.c sysdep.c util.c conf.c
TOPSRC=		${.CURDIR}/../..
TOPOBJ!=	cd ${TOPSRC}; printf "all:\n\t@pwd\n" |${MAKE} -f-
OS!=		awk '/^OS=/ { print $$2 }' ${.CURDIR}/../../Makefile
.PATH:		${TOPSRC} ${TOPSRC}/sysdep/${OS} ${TOPOBJ}
CFLAGS+=	-I${TOPSRC} -I${TOPSRC}/sysdep/${OS} -I${TOPOBJ} -Wall
NOMAN=
DEBUG=		-g

.include <bsd.prog.mk>

=== regress/group/Makefile ===
#	$OpenBSD: Makefile,v 1.8 2004/02/25 16:01:29 hshoexer Exp $
#	$EOM: Makefile,v 1.12 2000/04/07 20:19:43 niklas Exp $

# Test Group:

PROG=		grouptest
SRCS=		math_2n.c math_ec2n.c math_group.c grouptest.c log.c util.c \
		sysdep.c gmp_util.c conf.c
TOPSRC=		${.CURDIR}/../..
TOPOBJ!=	cd ${TOPSRC}; printf "all:\n\t@pwd\n" |${MAKE} -f-
OS!=		awk '/^OS=/ { print $$2 }' ${.CURDIR}/../../Makefile
FEATURES!=	awk '/^FEATURES=/ { print $$0 }' ${.CURDIR}/../../Makefile | sed 's/FEATURES=.//'
.PATH:		${TOPSRC} ${TOPSRC}/sysdep/${OS} ${TOPOBJ}
CFLAGS+=	-I${TOPSRC} -I${TOPSRC}/sysdep/${OS} -I${TOPOBJ} -Wall \
		-DUSE_EC
NOMAN=
LDADD+=		-lcrypto
DPADD+=		${LIBCRYPTO}
DEBUG=		-g

.if ${FEATURES:Mgmp} == "gmp"
CFLAGS+=	-DMP_FLAVOUR=MP_FLAVOUR_GMP
LDADD+=		-lgmp
DPADD+=		${LIBGMP}
.else
CFLAGS+=	-DMP_FLAVOUR=MP_FLAVOUR_OPENSSL
.endif

.include <bsd.prog.mk>

=== regress/hmac/Makefile ===
#	$OpenBSD: Makefile,v 1.4 1999/02/26 03:28:31 niklas Exp $
#	$EOM: Makefile,v 1.3 1999/02/25 15:14:24 niklas Exp $

# Test HMAC:

PROG=		hmactest
SRCS=		hash.c hmactest.c
TOPSRC=		${.CURDIR}/../..
TOPOBJ!=	cd ${TOPSRC}; printf "all:\n\t@pwd\n" |${MAKE} -f-
OS!=		awk '/^OS=/ { print $$2 }' ${.CURDIR}/../../Makefile
.PATH:		${TOPSRC} ${TOPSRC}/sysdep/${OS} ${TOPOBJ}
CFLAGS+=	-I${TOPSRC} -I${TOPSRC}/sysdep/${OS} -I${TOPOBJ} -Wall
NOMAN=
DEBUG=		-g

.include <bsd.prog.mk>

=== regress/prf/Makefile ===
#	$OpenBSD: Makefile,v 1.7 2004/02/25 16:01:29 hshoexer Exp $
#	$EOM: Makefile,v 1.6 2000/03/28 21:22:07 ho Exp $

# Test PRF:

PROG=		prftest
SRCS=		prf.c hash.c log.c prftest.c conf.c sysdep.c util.c
TOPSRC=		${.CURDIR}/../..
TOPOBJ!=	cd ${TOPSRC}; printf "all:\n\t@pwd\n" |${MAKE} -f-
OS!=		awk '/^OS=/ { print $$2 }' ${.CURDIR}/../../Makefile
.PATH:		${TOPSRC} ${TOPSRC}/sysdep/${OS} ${TOPOBJ}
CFLAGS+=	-I${TOPSRC} -I${TOPSRC}/sysdep/${OS} -I${TOPOBJ} -Wall
NOMAN=
DEBUG=		-g

.include <bsd.prog.mk>

=== debian/changelog ===
isakmpd (20041012-8) unstable; urgency=medium

  * QA upload.
  * Set maintainer to the QA group.
  * Port to OpenSSL 1.1, disable 40-bit DES, patch by Chris West.
    (Closes: #858931).
  * Newest and greatest compat (11), standards, R³.
  * Fix FTBFS with -Werror=format-security.
  * Fix FTBFS with ld --as-needed, by Ilya Barygin.  (Closes: #678295)
  * Fix typos in README.Debian and long desc.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 17 Mar 2018 22:38:39 +0100

isakmpd (20041012-7.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS by using OpenSSL 1.0.2. (Closes: #828355)

 -- Adrian Bunk <bunk@debian.org>  Fri, 13 Jan 2017 20:45:19 +0200

isakmpd (20041012-7.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fixup GNUmakefile for certpatch. Patch by Erwan Prioul (Closes: #749354).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Wed, 20 Apr 2016 21:40:11 +0200

isakmpd (20041012-7.2) unstable; urgency=low

  * Non-maintainer upload.
  * Fix FTBFS, fix for multiarched gmp (Closes: #654285)
    - Thanks to Philippe De Swert for patch.

 -- Hector Oron <zumbi@debian.org>  Wed, 22 Feb 2012 00:35:49 +0000

isakmpd (20041012-7.1) unstable; urgency=low

  * NMU.  Change dependency libgmp3-dev --> libgmp-dev.

 -- Steve M. Robbins <smr@debian.org>  Thu, 17 Mar 2011 21:40:04 -0500

isakmpd (20041012-7) unstable; urgency=low

  * Switch to dpkg-source 3.0 (quilt) format
  * Bump Standards version to 3.8.4
  * Add sysdep/common/libsysdep/.depend to clean target
  * Rename README.source to README.Debian-source

 -- Jochen Friedrich <jochen@scram.de>  Fri, 11 Jun 2010 17:49:04 +0200

isakmpd (20041012-6) unstable; urgency=low

  * Bumped standards version to 3.8.3.
  * Convert package to debhelper 7 and quilt patches.
  * Add patch to correct ifreq length. (Closes: #542641)
  * Depend on $network start and implement status command in init.d
    script

 -- Jochen Friedrich <jochen@scram.de>  Fri, 30 Oct 2009 17:53:02 +0100

isakmpd (20041012-5) unstable; urgency=low

  * Disable support for keynote as it seems to be broken.
  * Add dependency info to init.d script (Closes: #412893)
    Thanks to Petter Reinholdtsen <pere@hungry.com> for the patch.
  * Bumped standards version to 3.7.3 (No changes).

 -- Jochen Friedrich <jochen@scram.de>  Tue, 01 Apr 2008 17:30:53 +0200

isakmpd (20041012-4) unstable; urgency=high

  * Fix replay protection (CVE-2006-4436)
    Thanks to Stefan Fritsch <sf@fritsch.de> (Closes: #385894)

 -- Jochen Friedrich <jochen@scram.de>  Mon,  4 Sep 2006 18:41:00 +0200

isakmpd (20041012-3) unstable; urgency=low

  * Fix NAT-T RFC support.
  * Remove superfluos header from packet dump so tcpdump and ethereal
    can read the dump.

 -- Jochen Friedrich <jochen@scram.de>  Mon, 28 Aug 2006 17:14:47 +0200

sakmpd (20041012-2) unstable; urgency=low

  * New maintainer (Closes: #358800)
  * Replace SADB_X_SPDADD by SADB_X_SPDUPDATE (Closes: #346214)
  * Fix NAT-T (Closes: #324753)
  * Fix openssl incompatibility with version 0.9.8b (Closes: #334624)
  * Fix dependencies (Closes: #320393, #325849)
  * gcc compiler fixes (Closes: #318241)
  * Update standards version to 3.7.2

 -- Jochen Friedrich <jochen@scram.de>  Tue, 21 Feb 2006 14:26:40 +0100

isakmpd (20041012-1) unstable; urgency=high

  * new upstream cvs merge.
  * add setsockopt to properly configure udp encap socket.
  * add proper source port in nat-t sadb set (thanks to Thomas Walpuski).
  * DPD now works (closes: #258479).
  * NAT-T now works (closes: #269851).
  * remove double dependency on libkeynote0 (closes: #272377).

 -- Jean-Francois Dive <jef@debian.org>  Tue,  7 Sep 2004 11:28:18 +0200

isakmpd (20040628-1) unstable; urgency=high

  * New upstream cvs merge.
  * Enabled DPD.
  * Enabled NAT-T + added support for linux nat-t pfkey msgs.
  * Fix payload handling denial-of-service vuln (closes: #239739);
  * Add spd cleartext entry (thanks to Vincent Bernat). (closes: #243990).
  * Add dependency on linux-kernel-headers (closes: #238793).
  * Add man page for isakmpd.policy.
  * No issue with Renegotiate-on-HUP (closes: #255507).
  * x509v3.cnf provided (closes: #238542).
  * Added certpatch utility (closes: #231743).
  * Fixed pcap support (closes: #238543).

 -- Jean-Francois Dive <jef@debian.org>  Mon,  5 Jul 2004 23:32:47 +0200

=== debian/control ===
Source: isakmpd
Maintainer: Debian QA Group <packages@qa.debian.org>
Priority: optional
Section: net
Standards-Version: 4.1.3
Rules-Requires-Root: no
Build-Depends: debhelper (>= 11~), libssl-dev, libgmp-dev, libpcap-dev, linux-kernel-headers

Package: isakmpd
Priority: optional
Section: net
Architecture: any
Provides: ike-server
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base (>= 3.0-6)
Description: The Internet Key Exchange protocol openbsd implementation
 IKE is a protocol which allows one to exchange security information between
 to peers. This implementation requires the native Linux ipsec support.

=== debian/rules ===
#!/usr/bin/make -f

UPSTREAM_VERSION ?=20041012
b := $(CURDIR)/debian/isakmpd

%:
	dh $@

.PHONY: override_dh_auto_install
override_dh_auto_install:
	dh_auto_install
	dh_installdocs -n DESIGN-NOTES QUESTIONS README README.PKI TO-DO $(CURDIR)/debian/README.Debian x509v3.cnf
	cp $(CURDIR)/samples/*.conf $(b)/usr/share/doc/isakmpd/samples/
	cp $(CURDIR)/samples/VPN-east.conf $(b)/etc/isakmpd/isakmpd.conf
	cp $(CURDIR)/samples/policy $(b)/etc/isakmpd/isakmpd.policy
	cp $(CURDIR)/isakmpd $(b)/usr/sbin/
	cp $(CURDIR)/apps/certpatch/certpatch $(b)/usr/bin
	cp $(CURDIR)/debian/isakmpd.lintian $(b)/usr/share/lintian/overrides/isakmpd

.PHONY: override_dh_fixperms
override_dh_fixperms:
	dh_fixperms
	find $(b)/etc/isakmpd -type d | xargs chmod 0700
	find $(b)/etc/isakmpd -type f | xargs chmod 0600

.PHONY: get-orig-source
get-orig-source:
	@cd /tmp; cvs -d ":pserver:anoncvs@anoncvs.jp.openbsd.org:/cvs" co -D ${UPSTREAM_VERSION} src/sbin/isakmpd
	@cd /tmp/src/sbin; mv isakmpd isakmpd-${UPSTREAM_VERSION}; tar czf /tmp/isakmpd_${UPSTREAM_VERSION}.orig.tar.gz --exclude CVS isakmpd-${UPSTREAM_VERSION}
	@rm -rf /tmp/src
